/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-05 at 19:30:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.youtube.model;

/**
 * Ratings schemes. The country-specific ratings are mostly for movies and shows.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the YouTube Data API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ContentRating extends com.google.api.client.json.GenericJson {

  /**
   * Rating system in Australia - Australian Classification Board
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String acbRating;

  /**
   * British Board of Film Classification
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String bbfcRating;

  /**
   * Rating system in India - Central Board of Film Certification
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String cbfcRating;

  /**
   * Canadian Home Video Rating System
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String chvrsRating;

  /**
   * Rating system in Brazil - Department of Justice, Rating, Titles and Qualification
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String djctqRating;

  /**
   * Rating system in Japan - Eiga Rinri Kanri Iinkai
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String eirinRating;

  /**
   * Rating system in France - French Minister of Culture
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String fmocRating;

  /**
   * Rating system in Germany - Voluntary Self Regulation of the Movie Industry
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String fskRating;

  /**
   * Rating system in Spain - Instituto de Cinematografia y de las Artes Audiovisuales
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String icaaRating;

  /**
   * Rating system in South Korea - Korea Media Rating Board
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kmrbRating;

  /**
   * Motion Picture Association of America rating for the content.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String mpaaRating;

  /**
   * Rating system in New Zealand - Office of Film and Literature Classification
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String oflcRating;

  /**
   * Rating system in Mexico - General Directorate of Radio, Television and Cinematography
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String rtcRating;

  /**
   * Rating system in Russia
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String russiaRating;

  /**
   * TV Parental Guidelines rating of the content.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tvpgRating;

  /**
   * Internal YouTube rating.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String ytRating;

  /**
   * Rating system in Australia - Australian Classification Board
   * @return value or {@code null} for none
   */
  public java.lang.String getAcbRating() {
    return acbRating;
  }

  /**
   * Rating system in Australia - Australian Classification Board
   * @param acbRating acbRating or {@code null} for none
   */
  public ContentRating setAcbRating(java.lang.String acbRating) {
    this.acbRating = acbRating;
    return this;
  }

  /**
   * British Board of Film Classification
   * @return value or {@code null} for none
   */
  public java.lang.String getBbfcRating() {
    return bbfcRating;
  }

  /**
   * British Board of Film Classification
   * @param bbfcRating bbfcRating or {@code null} for none
   */
  public ContentRating setBbfcRating(java.lang.String bbfcRating) {
    this.bbfcRating = bbfcRating;
    return this;
  }

  /**
   * Rating system in India - Central Board of Film Certification
   * @return value or {@code null} for none
   */
  public java.lang.String getCbfcRating() {
    return cbfcRating;
  }

  /**
   * Rating system in India - Central Board of Film Certification
   * @param cbfcRating cbfcRating or {@code null} for none
   */
  public ContentRating setCbfcRating(java.lang.String cbfcRating) {
    this.cbfcRating = cbfcRating;
    return this;
  }

  /**
   * Canadian Home Video Rating System
   * @return value or {@code null} for none
   */
  public java.lang.String getChvrsRating() {
    return chvrsRating;
  }

  /**
   * Canadian Home Video Rating System
   * @param chvrsRating chvrsRating or {@code null} for none
   */
  public ContentRating setChvrsRating(java.lang.String chvrsRating) {
    this.chvrsRating = chvrsRating;
    return this;
  }

  /**
   * Rating system in Brazil - Department of Justice, Rating, Titles and Qualification
   * @return value or {@code null} for none
   */
  public java.lang.String getDjctqRating() {
    return djctqRating;
  }

  /**
   * Rating system in Brazil - Department of Justice, Rating, Titles and Qualification
   * @param djctqRating djctqRating or {@code null} for none
   */
  public ContentRating setDjctqRating(java.lang.String djctqRating) {
    this.djctqRating = djctqRating;
    return this;
  }

  /**
   * Rating system in Japan - Eiga Rinri Kanri Iinkai
   * @return value or {@code null} for none
   */
  public java.lang.String getEirinRating() {
    return eirinRating;
  }

  /**
   * Rating system in Japan - Eiga Rinri Kanri Iinkai
   * @param eirinRating eirinRating or {@code null} for none
   */
  public ContentRating setEirinRating(java.lang.String eirinRating) {
    this.eirinRating = eirinRating;
    return this;
  }

  /**
   * Rating system in France - French Minister of Culture
   * @return value or {@code null} for none
   */
  public java.lang.String getFmocRating() {
    return fmocRating;
  }

  /**
   * Rating system in France - French Minister of Culture
   * @param fmocRating fmocRating or {@code null} for none
   */
  public ContentRating setFmocRating(java.lang.String fmocRating) {
    this.fmocRating = fmocRating;
    return this;
  }

  /**
   * Rating system in Germany - Voluntary Self Regulation of the Movie Industry
   * @return value or {@code null} for none
   */
  public java.lang.String getFskRating() {
    return fskRating;
  }

  /**
   * Rating system in Germany - Voluntary Self Regulation of the Movie Industry
   * @param fskRating fskRating or {@code null} for none
   */
  public ContentRating setFskRating(java.lang.String fskRating) {
    this.fskRating = fskRating;
    return this;
  }

  /**
   * Rating system in Spain - Instituto de Cinematografia y de las Artes Audiovisuales
   * @return value or {@code null} for none
   */
  public java.lang.String getIcaaRating() {
    return icaaRating;
  }

  /**
   * Rating system in Spain - Instituto de Cinematografia y de las Artes Audiovisuales
   * @param icaaRating icaaRating or {@code null} for none
   */
  public ContentRating setIcaaRating(java.lang.String icaaRating) {
    this.icaaRating = icaaRating;
    return this;
  }

  /**
   * Rating system in South Korea - Korea Media Rating Board
   * @return value or {@code null} for none
   */
  public java.lang.String getKmrbRating() {
    return kmrbRating;
  }

  /**
   * Rating system in South Korea - Korea Media Rating Board
   * @param kmrbRating kmrbRating or {@code null} for none
   */
  public ContentRating setKmrbRating(java.lang.String kmrbRating) {
    this.kmrbRating = kmrbRating;
    return this;
  }

  /**
   * Motion Picture Association of America rating for the content.
   * @return value or {@code null} for none
   */
  public java.lang.String getMpaaRating() {
    return mpaaRating;
  }

  /**
   * Motion Picture Association of America rating for the content.
   * @param mpaaRating mpaaRating or {@code null} for none
   */
  public ContentRating setMpaaRating(java.lang.String mpaaRating) {
    this.mpaaRating = mpaaRating;
    return this;
  }

  /**
   * Rating system in New Zealand - Office of Film and Literature Classification
   * @return value or {@code null} for none
   */
  public java.lang.String getOflcRating() {
    return oflcRating;
  }

  /**
   * Rating system in New Zealand - Office of Film and Literature Classification
   * @param oflcRating oflcRating or {@code null} for none
   */
  public ContentRating setOflcRating(java.lang.String oflcRating) {
    this.oflcRating = oflcRating;
    return this;
  }

  /**
   * Rating system in Mexico - General Directorate of Radio, Television and Cinematography
   * @return value or {@code null} for none
   */
  public java.lang.String getRtcRating() {
    return rtcRating;
  }

  /**
   * Rating system in Mexico - General Directorate of Radio, Television and Cinematography
   * @param rtcRating rtcRating or {@code null} for none
   */
  public ContentRating setRtcRating(java.lang.String rtcRating) {
    this.rtcRating = rtcRating;
    return this;
  }

  /**
   * Rating system in Russia
   * @return value or {@code null} for none
   */
  public java.lang.String getRussiaRating() {
    return russiaRating;
  }

  /**
   * Rating system in Russia
   * @param russiaRating russiaRating or {@code null} for none
   */
  public ContentRating setRussiaRating(java.lang.String russiaRating) {
    this.russiaRating = russiaRating;
    return this;
  }

  /**
   * TV Parental Guidelines rating of the content.
   * @return value or {@code null} for none
   */
  public java.lang.String getTvpgRating() {
    return tvpgRating;
  }

  /**
   * TV Parental Guidelines rating of the content.
   * @param tvpgRating tvpgRating or {@code null} for none
   */
  public ContentRating setTvpgRating(java.lang.String tvpgRating) {
    this.tvpgRating = tvpgRating;
    return this;
  }

  /**
   * Internal YouTube rating.
   * @return value or {@code null} for none
   */
  public java.lang.String getYtRating() {
    return ytRating;
  }

  /**
   * Internal YouTube rating.
   * @param ytRating ytRating or {@code null} for none
   */
  public ContentRating setYtRating(java.lang.String ytRating) {
    this.ytRating = ytRating;
    return this;
  }

  @Override
  public ContentRating set(String fieldName, Object value) {
    return (ContentRating) super.set(fieldName, value);
  }

  @Override
  public ContentRating clone() {
    return (ContentRating) super.clone();
  }

}
